unit aro_classes;

{$mode objfpc}{$H+}
{$ASMmode intel}

  interface

 uses  Classes, SysUtils,  BaseUnix, aro_types, LCLIntf;

 Const Op_NeuAnlegen = O_TRUNC;//
       Op_Open  = 0;// 0; O_CREAT
       Seitenumbr : Byte = 10;

 Type
 TAroFile = class(TObject)
   private
      FHandle  : cint;
    protected
      Name     : PAnsiChar;
    public
      constructor CreateFil(FileName: PAnsiChar; Mode : Word);  reintroduce;
      constructor CreateFilOpExist(FileName: PAnsiChar; Var Exist : Boolean);
      destructor Destroy; override;
      function	Seek(Offset: Integer): Integer;
      procedure Seek_0 ;
      function 	Seek_EOF: Integer;
      function 	Seek_Diff(Offset: Integer): Integer;
      function	SeekRead( var Buf; Pos,Count : Integer): DWORD;  // liest ab pos
      procedure SetSize(NewSize: Integer);
      procedure Truncate;
      procedure TruncatePos(Pos : Integer);
      procedure Truncate_0;
      function	Read(var Buffer;Len:Integer): DWORD;
      function	ReadInt(var Buffer): DWORD;
      function	Write(const Buffer;Len:Integer): DWORD;
      function  WritePC(Buffer : PAnsiChar): DWORD;
      function  WriteLnPC(Buffer : PAnsiChar): DWORD;
      function  WriteStr(S : String): DWORD;
      function  WriteLn2PC(Buffer, Buffer_ : PAnsiChar): DWORD;
      function  WriteLn3PC(Buf, Buf2, Buf3 : PAnsiChar): DWORD;
      function  WriteLnZaPC(Za: Integer; Buffer : PAnsiChar): DWORD;
      procedure WriteNeueZeile;
		  procedure WriteLeer(Count: Word);
      function	GetPos: Integer;
      function	GetSize: Integer;
      function 	getDatName : PAnsiChar;
 end;

 TRecFile = class(TAroFile)
   private
    protected
      FRL			: Integer;  {Recordlänge}
    public
      constructor CreateFil(FileName: PAnsiChar; Mode, size : Word);  reintroduce;
      function	RecSeek(Offset: Integer): DWORD;
       function	RecSeekRead(var Buf; Pos : Integer ): DWORD;
      function	RecSeekWrite(var Buf; Pos : Integer ): DWORD;
      function	RecSeekFillWrite(Pos : Integer ): DWORD;
      function 	RecSeek_Diff(Offset: Integer): Integer;
      function	RecRead(var Buffer): DWORD;
      function	RecWrite(const Buffer): DWORD;
      procedure RecWriteLeer; //leeren Record anhängen um Lücken auszufüllen
      function	GetRecPos: Integer;
      function	GetRecSize: Integer;
 	end;

 TTextFile = class(TAroFile)
   private
     FNeueZeile : Integer;
     FLen : Integer;
   protected
   public
     constructor CreateFil(FileName: PAnsiChar; Mode, PCLen : Word); //  reintroduce;
     function ReadZeile(Zeile : PAnsiChar): integer;
     Procedure Reset;
   end;

 TXMLFile = class(TAroFile)
   private
     FNeueZeile : Integer;
     FLen : Integer;
   protected
   public
     constructor CreateFil(FileName: PAnsiChar; Mode, PCLen : Word); reintroduce;
     function ReadZeile(Zeile : PAnsiChar): Integer;
 	 end;

  Procedure Set_0_4(var adr; l : integer);  //Setzt variable mit L x 4-Bytes auf Wert 0000  assembler;
  Procedure Set_0(var adr; l : integer);    //Setzt variable mit L x 4-Bytes auf Wert 0000  assembler;
  function  GetCPUTick: QWord;
  procedure SetDatPfad;
  Function TestDatei(s:PAnsiChar): Boolean; // Es wird getestet ob Datei existiert
  Function IsExistDir(s:PAnsiChar): Boolean;   //Es wird getestet ob Verzeichnis existiert und ggf. angelegt
  Function TestDir(s:PAnsiChar): Boolean;   //Es wird getestet ob Verzeichnis existiert und ggf. angelegt
  function GetDatum : dat_sa;              {Result = PC-Datum}
	function GetZeit : 	Zeit_sa;             {Result = PC-Uhr}
  function GetDatumZeit : DatZeit_Sa;
  function GetDatZeitStr : PAnsiChar;
  function GetTxtStart(ss : PAnsiChar; var Pos : Integer; Max : Integer) :Boolean;
  function NoPfadNoExt (Str: PAnsiChar): PAnsiChar;
  function GetFileName(ss : PAnsiChar; ab : integer) : PAnsiChar;
  function MyStrRScan(Start, RePC : PAnsiChar; Ch : AnsiChar) : PAnsiChar;
  //function MyStrRScan_(Start, RePC : PAnsiChar; Ch : AnsiChar) : PAnsiChar;
  function  StrCopy1St(Dest, Str1: PAnsiChar): PAnsiChar;
	function  StrCopy2St(Dest, Str1, Str2: PAnsiChar): PAnsiChar;
	function  StrCopy3St(Dest, Str1, Str2, Str3: PAnsiChar): PAnsiChar;
	function  StrCopy4St(Dest, Str1, Str2, Str3, Str4 : PAnsiChar): PAnsiChar;
	function  StrCopy5St(Dest, Str1, Str2, Str3, Str4, Str5 : PAnsiChar): PAnsiChar;
	function  StrCopy6St(Dest, Str1, Str2, Str3, Str4, Str5, Str6 : PAnsiChar): PAnsiChar;
	function  StrCopy7St(Dest, Str1, Str2, Str3, Str4 ,Str5, Str6, Str7 : PAnsiChar): PAnsiChar;
	function  StrCopy8St(Dest, Str1, Str2, Str3, Str4 ,Str5, Str6, Str7, Str8 : PAnsiChar): PAnsiChar;
  Procedure LetztesZeichenWeg(Var PC: PAnsiChar);
  Procedure AnsiCharAnhaengen(Var PC: PAnsiChar; C: AnsiChar);
  function  DrawHexWert(Ziel : PAnsiChar; Wert : DWord; anz : Integer): PAnsiChar;
  procedure LZ_Anh_PCInc(var Ziel : PAnsiChar; anz : Integer);
  procedure DrawHexWertLz(Ziel : PAnsiChar; Wert : DWord; anz : Integer);
  function  DecodeHexWert(var Ziel : PAnsiChar;  anz : Integer) : DWord;
  function  DecodeHexByte(var Ziel : PAnsiChar): Byte;
  function  GetIntStr(Wert : Integer): PAnsiChar;
  function  GetIntStrLn(Wert, Ln : Integer): PAnsiChar;   overload;
  function  GetIntStrLn(PC : PAnsiChar; Wert, Ln : Integer) : PAnsiChar;  overload;
  function  LeerZeichenWeg(ss : PAnsiChar; Anf, Max : Integer): integer;
  function  CopyUpCase(Qu, Zi : PAnsiChar; var Anf : Integer; Max : Integer) : integer;
  function  CopyUpCaseEnde(Qu, Zi : PAnsiChar; Anf, Max : Integer; E : Char) : integer;
  function  CopyEnde(Qu, Zi : PAnsiChar; var Anf : Integer; Max : Integer; E : Char) : integer;
  procedure StrDisposeAndNil(var PAC);
  Procedure Dat_Str(da :dat_sa; s:PAnsiChar);  {aus Datumssatz wird Str}
  Procedure Zeit_Str(Zs :Zeit_sa; ss : PAnsiChar);  {aus Zeitsatz wird Str}
  Procedure Zeit_Str_SM(Zs :Zeit_sa; ss : PAnsiChar);  {aus Zeitsatz wird Str - St :Min}
  Procedure DatZeit_Str(dad :dat_sa; dat :Zeit_Sa; s:PAnsiChar);  {aus Datum und Zeitsatz wird Str}
  procedure FillZeile__(var P : Pointer; Farbe, Anz, Rest : DWORD);

 Var DatIsNeu: Boolean;
     ProPfad, DatPfad : PAnsiChar; // TempPfad, FreigabePfad,DatPfad, PrivatDatPfad,DocPfad, SprachPfad

implementation

uses LCLType;


procedure FillZeile__(Var P : Pointer; Farbe, Anz, Rest : DWORD); assembler;
asm                       //RDI,            RSI,  RDX  , RCX, R8,   R9      6298AA8    ,16777215, 68, 0
  MOV   RDI, RAX                      //3305640
  MOV   RAX, RSI  // Farbe            //     912
  MOV   RSI, RCX  // Rest             //272
  MOV   RCX, RDX  // Anzahl
  repne STOSD

  MOV   RAX, RDI
 // MOV   RSI, RDI
 // MOV   RDX, RDI
 // MOV   RCX, RDI
end;

constructor TTextFile.CreateFil(FileName: PAnsiChar; Mode, PCLen  : Word);
begin
   Inherited CreateFil(FileName, Mode);
   FNeueZeile := 0;
   FLen := PCLen;
end;

Procedure TTextFile.Reset;
begin
  Seek_0;
  FNeueZeile := 0;
end;

function TTextFile.ReadZeile(Zeile : PAnsiChar): integer;
Var Start, i, k : Integer;

begin
  Start := 0;
  Seek(FNeueZeile);
  repeat
    k := Read(Zeile[Start], 64);
    if k = 0 then Exit(-1);  // Dateiende erreicht > Zeile = Nil;
    for i := Start to Start + k -1 do begin
      if Zeile[i] = #10 then begin  // Anfang Zeileninhalt gefunden
        Zeile[i] := #0;
        inc(FNeueZeile ,( i +1));
        if Zeile[i-1] = #13 then Zeile[i-1] := #0; //inc(FNeueZeile);
        Exit(i);
      end;
    end; // gelesener Bereich zu ende aber Endmarke noch nicht gefunden
    if k < 64 then begin
      inc(FNeueZeile , i+1);
      Zeile[i+1] := #0;
      Exit(i+1);
    end;
    inc( Start, 64);
    if Start > FLen then exit(-2); // Max Zeilenlänge erreicht
  until false;
end;

constructor TXMLFile.CreateFil(FileName: PAnsiChar; Mode, PCLen : Word);
begin
   Inherited CreateFil(FileName, Mode);
   FNeueZeile := 0;
   FLen := PCLen;
end;

function TXMLFile.ReadZeile(Zeile : PAnsiChar): Integer;
Var Start, i : Integer; //  ZeiAnfang
begin
  Start := 0;
  Seek(FNeueZeile);
  Result := 0;
  repeat
    i := Read(Zeile[Start], 64);
    if i = 0 then Exit(-1);  // Dateiende erreicht > Zeile = Nil;
    for i := Start to Start +63 do begin
      if Zeile[i] = '<' then begin  // Anfang Zeileninhalt gefunden
        if Result = 0 then Result := i; // < können in Zeile mehrfach vorkommen!
      end;
      if Zeile[i] = #13 then begin  // Anfang Zeileninhalt gefunden
        Zeile[i] := #0;
        inc(FNeueZeile ,( i +1));
        Exit;
      end;
    end; // gelesener Bereich zu ende aber Endmarke noch nicht gefunden
    inc( Start, 64);
    if Start > FLen then exit(-2); // Max Zeilenlänge erreicht
  until false;
end;

//TAroFile.TAroFile.TAroFile.TAroFile.TAroFile.TAroFile.TAroFile.TAroFile.TAroFile.TAroFile.TAroFile.TAroFile.TAroFile.TAroFile.TAroFile.TAroFile.TAroFile.TAroFile.
constructor TAroFile.CreateFil(FileName: PAnsiChar; Mode : Word);
Var Flag : Integer;
begin
  Name := StrNew(FileName);
  Flag := O_RDWR or Mode;
  DatIsNeu := false;
  FHandle := FpOpen(FileName,Flag);
  if FHandle < 1 then begin  //wenn nicht möglich dann ...
    DatIsNeu := true;
    Flag := Flag or O_CREAT;
    FHandle := FpOpen(FileName, Flag);
    if FHandle < 1 then begin  //wenn nicht möglich dann ...
      FreeAndNil(self);
    end;
  end;
end;

constructor TAroFile.CreateFilOpExist(FileName: PAnsiChar; Var Exist : Boolean);
Var Flag : Integer;
begin
  Flag := O_RDWR;
  FHandle := FpOpen(FileName,Flag);
  if FHandle < 1 then begin  //wenn nicht vorhanden dann ...
     Exist := false;
     exit;
  end else begin
    Exist := true;
    Name := StrNew(FileName);
  end;
end;

destructor TAroFile.Destroy;
begin
  StrDispose(Name);
  Name := Nil;
  if FHandle > 0 then  fpclose(FHandle);
  FHandle := 0;

end;

function TAroFile.Seek(Offset: Integer): Integer;
begin
  Result := FileSeek(FHandle, Offset , fsFromBeginning);
end;

procedure TAroFile.Seek_0;
begin
  FileSeek(FHandle, 0, fsFromBeginning);
end;

function TAroFile.Seek_EOF: Integer;
begin
  Result := FileSeek(FHandle, 0, fsFromEnd);
end;

function TAroFile.Seek_Diff(Offset: Integer): Integer;
begin
  Result := FileSeek(FHandle, Offset , fsFromCurrent);
end;

function TAroFile.SeekRead( var Buf ; Pos,Count : Integer): DWORD;
begin
  FileSeek(FHandle, Pos, fsFromBeginning);
  Result :=  FpRead(FHandle, Buf, Count);
end;

procedure TAroFile.SetSize(NewSize: Integer);
begin
  FileTruncate (FHandle, NewSize);
end;

procedure TAroFile.Truncate;
Var i : Integer;
begin
  i := FileSeek(FHandle, 0, fsFromEnd);
  FileTruncate (FHandle, I);
end;

procedure TAroFile.TruncatePos(Pos : Integer);
begin
  FileTruncate (FHandle, Pos);
  FileSeek(FHandle, Pos, fsFromBeginning);
end;

procedure TAroFile.Truncate_0;
begin
  FileTruncate (FHandle, 0);
  FileSeek(FHandle, 0, fsFromBeginning);
end;

function TAroFile.Read(var Buffer;Len:Integer): DWORD;
begin
  Result :=  FpRead(FHandle, Buffer, Len);
end;

function TAroFile.ReadInt(var Buffer): DWORD;
begin
  Result :=  FpRead(FHandle, Buffer, 4);
end;

function TAroFile.Write(const Buffer; Len:Integer): DWORD;
begin
  Result := FpWrite( FHandle, Buffer, Len);
end;

function TAroFile.WritePC(Buffer : PAnsiChar): DWORD;
Var Len : Integer;
begin
  Len := StrLen(Buffer);
  Result := FpWrite( FHandle, Buffer, Len);
end;

function TAroFile.WriteLnPC(Buffer : PAnsiChar): DWORD;
Var Len : Integer;
begin
  Len := StrLen(Buffer);
  if Len > 0 then Result := FpWrite( FHandle, Buffer, Len);
  FpWrite( FHandle, Seitenumbr, 1);
end;

function TAroFile.WriteStr(S : String): DWORD;
Var Len : Integer;
begin
  Len := Length(s);
  if Len > 0 then Result := FpWrite( FHandle, PAnsiChar(s), Len);
  FpWrite( FHandle, Seitenumbr, 1);
end;

function TAroFile.WriteLn2PC(Buffer, Buffer_ : PAnsiChar): DWORD;
Var Len : Integer;
begin
  Result := 0;
  Len := StrLen(Buffer);
  if Len > 0 then Result := FpWrite( FHandle, Buffer, Len);
  Len := StrLen(Buffer_);
  if Len > 0 then Result := FpWrite( FHandle, Buffer_, Len) + Result;
  FpWrite( FHandle, Seitenumbr, 1);
end;

function  TAroFile.WriteLn3PC(Buf, Buf2, Buf3 : PAnsiChar): DWORD;
Var Len : Integer;
begin
  Result := 0;
  Len := StrLen(Buf);
  if Len > 0 then Result := FpWrite( FHandle, Buf, Len);
  Len := StrLen(Buf2);
  if Len > 0 then Result := FpWrite( FHandle, Buf2, Len) + Result;
  Len := StrLen(Buf3);
  if Len > 0 then Result := FpWrite( FHandle, Buf3, Len) + Result;
  FpWrite( FHandle, Seitenumbr, 1);
end;

function TAroFile.WriteLnZaPC(Za: Integer; Buffer : PAnsiChar): DWORD;
Var Len : Integer;
    PC : PAnsiChar;
begin
  PC := GetIntStr(Za);
  Len := StrLen(PC);
  if Len > 0 then Result := FpWrite( FHandle, PC, Len);
  Len := StrLen(Buffer);
  if Len > 0 then Result := FpWrite( FHandle, Buffer, Len);
  FpWrite( FHandle, Seitenumbr, 1);
end;

procedure TAroFile.WriteNeueZeile;
begin
  FpWrite( FHandle, Seitenumbr, 1);
end;

procedure TAroFile.WriteLeer(Count: Word);
Var s : Array [0..255] of AnsiChar;
 		i,  ii : Integer;
begin
  {$HINTS OFF}
  set_0(s  ,Sizeof(s));
  i := Count and $FF;
  if i > 0 then FpWrite( FHandle, s, i);
  ii := Count SHR 8;
  for i := 1 to ii do FpWrite( FHandle, s, 256);
  {$HINTS ON}
end;

function TAroFile.GetPos: Integer;
begin
  Result := FileSeek(FHandle, 0, fsFromCurrent);
end;

function TAroFile.GetSize: Integer;
Var i : Integer;
begin
  i := FileSeek(FHandle, 0, fsFromCurrent); //Akt Pos merken
  Result := FileSeek(FHandle, 0, fsFromEnd);
  FileSeek(FHandle, i, fsFromBeginning);
end;

function 	TAroFile.getDatName : PAnsiChar;
begin
 	Result :=Name;
end;

//TRecFile.TRecFile.TRecFile.TRecFile.TRecFile.TRecFile.TRecFile.TRecFile.TRecFile.
constructor TRecFile.CreateFil(FileName: PAnsiChar; Mode, size : Word);
begin
  Inherited CreateFil(FileName, Mode);
  FRL := size;
end;

function TRecFile.RecSeek(Offset: Integer): DWORD;
begin
  Result := FileSeek(FHandle, Offset * FRL, fsFromBeginning);
end;

function TRecFile.RecSeekRead(var Buf; Pos : Integer ): DWORD;
begin
  FileSeek(FHandle, Pos * FRL, fsFromBeginning);
  Result := FpRead(FHandle, Buf, FRL);
end;

function TRecFile.RecSeekwrite(var Buf; Pos : Integer ): DWORD;
begin
  FileSeek(FHandle, Pos * FRL, fsFromBeginning);
  Result := FpWrite( FHandle, Buf, Pos * FRL);
end;

function TRecFile.RecSeekFillWrite(Pos : Integer ): DWORD;
Var ist  : Integer;
begin
  ist := round(FileSeek(FHandle, 0, fsFromEnd) / FRL); // Anzahl ermitteln
  if ist < Pos -1 then begin  // Auffüllen
    WriteLeer((Pos - ist - 1) * FRL);
    FileSeek(FHandle, Pos * FRL, fsFromBeginning);
    Result := 0;
  end else begin
    FileSeek(FHandle, Pos * FRL, fsFromBeginning);
    Result := 0;
  end;
end;

function  TRecFile.RecSeek_Diff(Offset: Integer): Integer;
begin
  Result := FileSeek(FHandle, Offset * FRL, fsFromCurrent);
end;

function TRecFile.RecRead(var Buffer): DWORD;
begin
  Result :=  FpRead(FHandle, Buffer, FRL);
end;

function TRecFile.RecWrite(const Buffer): DWORD;
begin
  Result := FpWrite( FHandle, Buffer, FRL);
end;

procedure TRecFile.RecWriteLeer;  //leren Record anhängen um Lücken auszufüllen
Var b : Array [0..255] of Byte;
    i, ii : Integer;
begin
  {$HINTS OFF}
  set_0_4(b  ,64);
  i := FRL and $FF;
  if i > 0 then FpWrite( FHandle, b, i);
  ii := FRL SHL 8;
  for i := 1 to ii do FpWrite(FHandle, b, 256);
  {$HINTS ON}
end;

function TRecFile.GetRecPos: Integer;
begin
  Result := round(FileSeek(FHandle, 0, fsFromCurrent) / FRL);
end;

function TRecFile.GetRecSize: Integer;
begin
  Result := round(FileSeek(FHandle, 0, fsFromEnd) / FRL);
end;

procedure set_0(var adr ; l : integer); assembler;
asm             //RDI,  RSI
 	    //PUSH RDI  //Adresse
			xor EAX,EAX
      MOV RCX, RSI
			CLD
			SHR RCX,1  // Bit 0 in C Flag
  		JNC	@@1
  		STOSB      // kleinste Adresse auf 0 swtzen
@@1:	SHR RCX,1  // Bit 1 in C Flag
  		JNC	@@2
  		STOSW      // kleinste Adresse auf 0 swtzen
@@2:	REP STOSD
			//POP	RDI
end;

Procedure set_0_4(var adr ; l : integer);  assembler;
asm            //EAX = v1		,EDX = v2 }
 	PUSH RDI
 	MOV		EDI,EAX    //di 0 adresse
 	xor EAX,EAX
 	CLD
 	MOV	ECX,EDX
 	REP STOSD
 	POP	RDI
end;

function GetCPUTick: QWord; assembler;
asm
  DB $0F,$31   //RDTSC code.
end;


procedure SetProPfad;
Var PC : PAnsiChar;
    ss : Array [0..255] of AnsiChar;
begin
  if ProPfad <> Nil then exit; //Doppelten Aufruf verhindern
  SS := Paramstr(0);   //Application.ExeName;
  PC := StrRScan(ss, '/');
  if PC <> Nil then PC[1] := #0;
  ProPfad := StrNew(ss);
end;

procedure SetDatPfad;
Var ss : Array [0..255] of AnsiChar;
    PC : PAnsiChar;
begin
  PC := StrCopy2St(ss ,ProPfad,'dat');
  TestDir(ss);
  AnsiCharAnhaengen(PC, '/');
  DatPfad := StrNew(ss);
end;

Function TestDatei(s:PAnsiChar): Boolean;   //Es wird getestet ob Datei
Var Info : TSearchRec;
begin
  Result :=  FindFirst (s, faArchive, Info) = 0; //  faAnyFile and faDirectory
  FindClose(Info);
end;

Function IsExistDir(s:PAnsiChar): Boolean;   //Es wird getestet ob Verzeichnis existiert und ggf. angelegt
Var Info : TSearchRec;
begin
  Result := FindFirst (s, faDirectory, Info) = 0 ;
  FindClose(Info);
end;

Function TestDir(s:PAnsiChar): Boolean;   //Es wird getestet ob Verzeichnis existiert und ggf. angelegt
Var Info : TSearchRec;
begin
  Result := false;
  if FindFirst (s, faDirectory, Info) <> 0 then begin
    CreateDir(s);
    Result := true; // true = Verzeichnis neu angelegt
  end;
  FindClose(Info);
end;

{$HINTS OFF}
function GetDatum : dat_sa;
var	SystemTime: TSystemTime;
begin
	GetLocalTime(SystemTime);
	with SystemTime do begin
		Result.t := Day;
		Result.m := Month;
		Result.j := Year;
	end;
end;

function GetZeit : 	Zeit_sa;
var	SystemTime: TSystemTime;
begin
	GetLocalTime(SystemTime);
	with SystemTime do begin
		Result.h := Hour;
		Result.mi := Minute;
		Result.s := Second;
		Result.ms := MilliSecond shr 2;
	end;
end;

function GetDatumZeit : DatZeit_Sa;
var	SystemTime: TSystemTime;
begin
	GetLocalTime(SystemTime);
	with SystemTime do begin
    Result.t := Day;
		Result.mo := Month;
		Result.j := Year;
    Result.h := Hour;
		Result.mi := Minute;
		Result.s := Second;
		Result.ms := MilliSecond shr 2;
	end;
end;

function GetDatZeitStr : PAnsiChar;
var	SystemTime: TSystemTime;
    ss : Array [0..255] of AnsiChar;
    i, Pos : Integer;
begin
	GetLocalTime(SystemTime);
  Pos := 0;
	with SystemTime do begin
    dec(Year, 2000);
    for i := 0 to 1 do begin
      ss[Pos] := ZiffAr_2[Day][i];
      inc(Pos);
    end;
    ss[Pos] := '.';  inc(Pos);
    for i := 0 to 1 do begin
      ss[Pos] := ZiffAr_2[Month][i];
      inc(Pos);
    end;
    ss[Pos] := '.';  inc(Pos);
    ss[Pos] := '2';  inc(Pos);
    ss[Pos] := '0';  inc(Pos);
    for i := 0 to 1 do begin
      ss[Pos] := ZiffAr_2[Year][i];
      inc(Pos);
    end;
    ss[Pos] := ' ';  inc(Pos);
    ss[Pos] := '-';  inc(Pos);
    ss[Pos] := ' ';  inc(Pos);
    for i := 0 to 1 do begin
      ss[Pos] := ZiffAr_2[Hour][i];
      inc(Pos);
    end;
    ss[Pos] := ':';  inc(Pos);
      for i := 0 to 1 do begin
      ss[Pos] := ZiffAr_2[Minute][i];
      inc(Pos);
    end;
    ss[Pos] := ':';  inc(Pos);
    for i := 0 to 1 do begin
      ss[Pos] := ZiffAr_2[Second][i];
      inc(Pos);
    end;
    ss[Pos] := #0;
  end;
  Result := ss;
end;
{$HINTS ON}

function NoPfadNoExt (Str: PAnsiChar): PAnsiChar;
Var ss : Array [0..255] of AnsiChar;
    PC : PAnsiChar;
    i : integer;
begin
  PC := StrRScan(Str, '/');   //nach Pfad alles abtrennen
  if PC <> Nil then begin
    StrCopy(ss, PC +1);
    for i := 1 to 31 do begin
      if ss[i] = '.' then begin
        ss[i] := #0;
        exit(ss);
      end;
    end;
	end;
end;

function GetFileName(ss : PAnsiChar; ab : integer) : PAnsiChar;
Var Anf, i : Integer;
begin
  for i := Ab to 255 do begin
    if ss[i] > #64 then begin
      Anf := i;
      Result := ss + i;
      break;
    end;
  end;
  for i := Anf to 511 do begin
    if (ss[i] < #65) and (ss[i] <> '.') then begin
      ss[i] := #0;
      exit;
    end;
  end;
end;

{ Variante ohne Assembler; Bei langen Zeichenketten schneller als StrRScan
function MyStrRScan(Start, RePC : PAnsiChar; Ch : AnsiChar) : PAnsiChar;
Var Anz, i : Integer;
begin
  Result := Nil;
  Anz := RePC - Start -1;
  for i := Anz downto 0 do begin
    if Start[i] = Ch then begin
      Result := Start + i;
      break;
    end;
  end;
end;    }

function MyStrRScan(Start, RePC : PAnsiChar; Ch : AnsiChar) : PAnsiChar;   assembler;
asm  	              //RDI,  RSI,  RDX         Res. = RAX
  DEC RSI
  MOV RCX, RSI
  SUB RCX, RDI
  mov RAX, RDX
  mov RDI, RSI
  STD
  repne scasb
  CLD
  je @@found
  MOV   RAX, 0
  jmp @@exit
@@found:
  MOV RAX, RDI
  INC RAX
@@exit:
end;

function  StrCopy1St(Dest, Str1: PAnsiChar): PAnsiChar;  assembler;
asm  	            //RDI,  RSI,  RDX         Res. = RAX
@@1:	LODSB
      OR		AL, AL    //wenn #0
      STOSB
      JNE		@@1
      MOV   RAX, RDI
      dec RAX
end;

function StrCopy2St(Dest, Str1, Str2: PAnsiChar): PAnsiChar;  assembler;
asm  	            //RDI,  RSI,  RDX         Res. = RAX
@@1:	LODSB
      STOSB
      OR  AL, AL    //wenn #0
      JNE	@@1
      dec  RDI
      MOV   RSI, RDX
@@2:	LODSB
      STOSB
      OR		AL, AL    //wenn #0
      JNE		@@2
      dec  RDI
      MOV   RAX, RDI
end;

function StrCopy3St(Dest, Str1, Str2, Str3: PAnsiChar): PAnsiChar; assembler;
asm  	            //RDI,  RSI,  RDX,  RCX   Res. = RAX
@@1:	LODSB
      STOSB
      OR		AL, AL    //wenn #0
      JNE		@@1
      dec  RDI
      MOV   RSI, RDX
@@2:	LODSB
      STOSB
      OR		AL, AL    //wenn #0
      JNE		@@2
      dec  RDI
      MOV   RSI, RCX
@@3:	LODSB
      STOSB
      OR		AL, AL    //wenn #0
      JNE		@@3
      dec  RDI
      MOV   RAX, RDI
end;

function StrCopy4St(Dest, Str1, Str2, Str3, Str4 : PAnsiChar): PAnsiChar;  assembler;
asm  	            //RDI,  RSI,  RDX,  RCX,  R8,   R9         Res. = RAX
@@1:	LODSB
      STOSB
      OR		AL, AL    //wenn #0
      JNE		@@1
      dec  RDI
      MOV   RSI, RDX
@@2:	LODSB
      STOSB
      OR		AL, AL    //wenn #0
      JNE		@@2
      dec  RDI
      MOV   RSI, RCX
@@3:	LODSB
      STOSB
      OR		AL, AL    //wenn #0
      JNE		@@3
      dec  RDI
      MOV   RSI, R8
@@4:	LODSB
      STOSB
      OR		AL, AL    //wenn #0
      JNE		@@4
      dec  RDI
      MOV   RAX, RDI
end;

function StrCopy5St(Dest, Str1, Str2, Str3, Str4, Str5 : PAnsiChar): PAnsiChar; assembler;
asm  	            //RDI,  RSI,  RDX,  RCX,  R8,   R9    Res. = RAX
@@1:	LODSB
      STOSB
      OR	  AL, AL    //wenn #0
      JNE	  @@1
      dec   RDI
      MOV   RSI, RDX
@@2:	LODSB
      STOSB
      OR		AL, AL    //wenn #0
      JNE		@@2
      dec  RDI
      MOV   RSI, RCX
@@3:	LODSB
      STOSB
      OR		AL, AL    //wenn #0
      JNE		@@3
      dec  RDI
      MOV   RSI, R8
@@4:	LODSB
      STOSB
      OR		AL, AL    //wenn #0
      JNE		@@4
      dec  RDI
      MOV   RSI, R9
@@5:	LODSB
      STOSB
      OR		AL, AL    //wenn #0
      JNE		@@5
      dec  RDI
      MOV   RAX, RDI
end;

function StrCopy6St(Dest, Str1, Str2, Str3, Str4 ,Str5, Str6 : PAnsiChar): PAnsiChar; assembler;
asm  	            //RDI,  RSI,  RDX,  RCX,  R8,   R9
@@1:	LODSB
      STOSB
      OR		AL, AL    //wenn #0
      JNE		@@1
      dec  RDI
      MOV   RSI, RDX
@@2:	LODSB
      STOSB
      OR		AL, AL    //wenn #0
      JNE		@@2
      dec  RDI
@@3:	LODSB
      STOSB
      OR		AL, AL    //wenn #0
      JNE		@@3
      dec  RDI
      MOV   RSI, R8
@@4:	LODSB
      STOSB
      OR		AL, AL    //wenn #0
      JNE		@@4
      dec  RDI
      MOV   RSI, R9
@@5:	LODSB
      STOSB
      OR		AL, AL    //wenn #0
      JNE		@@5
      dec  RDI
      MOV   RSI, Str6
@@6:  LODSB
      STOSB
      OR		AL, AL    //wenn #0
      JNE		@@6
      dec  RDI
      MOV   RAX, RDI
end;

function StrCopy7St(Dest, Str1, Str2, Str3, Str4 ,Str5, Str6, Str7 : PAnsiChar): PAnsiChar; assembler;
asm  	            //RDI,  RSI,  RDX,  RCX,  R8,   R9
@@1:	LODSB
      STOSB
      OR		AL, AL    //wenn #0
      JNE		@@1
      dec  RDI
      MOV   RSI, RDX
@@2:	LODSB
      STOSB
      OR		AL, AL    //wenn #0
      JNE		@@2
      dec  RDI
      MOV   RSI, RCX
@@3:	LODSB
      STOSB
      OR		AL, AL    //wenn #0
      JNE		@@3
      dec  RDI
      MOV   RSI, R8
@@4:	LODSB
      STOSB
      OR		AL, AL    //wenn #0
      JNE		@@4
      dec  RDI
      MOV   RSI, R9
@@5:	LODSB
      STOSB
      OR		AL, AL    //wenn #0
      JNE		@@5
      dec   RDI
      MOV   RSI, Str6
@@6:  LODSB
      STOSB
      OR		AL, AL    //wenn #0
      JNE		@@6
      dec   RDI
      MOV   RSI, Str7
@@7:  LODSB
      STOSB
      OR		AL, AL    //wenn #0
      JNE		@@7
      dec   RDI
      MOV   RAX, RDI
end;

function StrCopy8St(Dest, Str1, Str2, Str3, Str4 ,Str5, Str6, Str7, Str8 : PAnsiChar): PAnsiChar; assembler;
asm  	            //RDI,  RSI,  RDX,  RCX,  R8,   R9
@@1:	LODSB
      STOSB
      OR		AL, AL    //wenn #0
      JNE		@@1
      dec  RDI
      MOV   RSI, RDX
@@2:	LODSB
      STOSB
      OR		AL, AL    //wenn #0
      JNE		@@2
      dec  RDI
      MOV   RSI, RCX
@@3:	LODSB
      STOSB
      OR		AL, AL    //wenn #0
      JNE		@@3
      dec  RDI
      MOV   RSI, R8
@@4:	LODSB
      STOSB
      OR		AL, AL    //wenn #0
      JNE		@@4
      dec  RDI
      MOV   RSI, R9
@@5:	LODSB
      STOSB
      OR		AL, AL    //wenn #0
      JNE		@@5
      dec  RDI
      MOV   RSI, Str6
@@6:  LODSB
      STOSB
      OR		AL, AL    //wenn #0
      JNE		@@6
      dec  RDI
      MOV   RSI, Str7
@@7:  LODSB
      STOSB
      OR		AL, AL    //wenn #0
      JNE		@@7
      dec   RDI
      MOV   RSI, Str8
@@8:  LODSB
      STOSB
      OR		AL, AL    //wenn #0
      JNE		@@8
      dec   RDI
      MOV   RAX, RDI
end;

Procedure LetztesZeichenWeg(Var PC: PAnsiChar);
begin
  dec(PC);
  PC := #0;
end;

Procedure AnsiCharAnhaengen(Var PC: PAnsiChar; C: AnsiChar);
begin
  PC[0] := C;
  inc(PC);
  PC[0] := #0;
end;

function  DrawHexWert(Ziel : PAnsiChar; Wert : DWord; anz : Integer): PAnsiChar;
var i : Integer;
begin
  Result := Ziel + anz;
  Ziel[Anz] := #0;
  for i := anz -1  downto 0 do begin
    Ziel[i] := HeZiffAr[Wert and 15];
    Wert := wert shr 4;
  end;
end;

procedure LZ_Anh_PCInc(var Ziel : PAnsiChar; anz : Integer);
var i : Integer;
begin
  for i := 0   to anz -1  do Ziel[i] := ' ';
  Ziel[Anz] := #0;
  inc(Ziel, anz);
end;

procedure DrawHexWertLz(Ziel : PAnsiChar; Wert : DWord; anz : Integer);
var i : Integer;
begin
  for i := anz -1  downto 0 do begin
    Ziel[i] := HeZiffAr[Wert and 15];
    Wert := wert shr 4;
  end;
  for i := anz   to anz +5 do begin
    Ziel[i] := '.';
  end;
  Ziel[Anz+6] := #0;
end;

function DecodeHexWert(var Ziel : PAnsiChar;  anz : Integer) : DWord;
var i, HexWert : Integer;
begin
  Result := 0;
  for i := 1 to anz do begin
    Result := Result shl 4;
    HexWert:= ord(Ziel[0]) -48;
    if HexWert > 9 then dec(HexWert,7);
    Result := Result  or HexWert;
    inc(Ziel);
  end;
end;

function DecodeHexByte(var Ziel : PAnsiChar): Byte;
begin
  Result := ord(Ziel[0]) -48;
  if Result > 9 then dec(Result,7);
  inc(Ziel);
end;

function GetIntStr(Wert : Integer): PAnsiChar;
Var s : string;
    ss : Array [0..31] of AnsiChar;
begin
  if (Wert >= 0) and (Wert < 257)then begin
    Result := ZiffAr_2[Wert];
  end else begin
    str(Wert, s);
    strpcopy(ss,s);
    Result := ss;
  end;
end;

function GetIntStrLn(Wert, Ln : Integer): PAnsiChar;
Var s : string;
    ss : Array [0..31] of AnsiChar;
    l, i : integer;
begin
  for i := 0 to Ln-1  do ss[i] := 'x';
  if Wert < 100 then begin
    StrCopy(ss +ln -2, ZiffAr_2[Wert]);
    exit(ss);
  end;
  if (Wert >= 0) and (Wert < 257)then begin
    StrCopy(ss +ln -3, ZiffAr_2[Wert]);
    exit(ss);
  end;
  str(Wert, s);
  l := Length(s);
  StrPCopy(ss +ln -l, s);
  Result := ss;
end;

function  GetIntStrLn(PC : PAnsiChar; Wert, Ln : Integer) : PAnsiChar;
Var s : string;
    l, i : integer;
begin
  Result := PC + Ln;
  for i := 0 to Ln-1  do PC[i] := ' ';
  if Wert < 100 then begin
    StrCopy(PC +ln -2, ZiffAr_2[Wert]);
    exit;
  end;
  if (Wert >= 0) and (Wert < 257)then begin
    StrCopy(PC +ln -3, ZiffAr_2[Wert]);
    exit;
  end;
  str(Wert, s);
  l := Length(s);
  StrPCopy(PC +ln -l, s);


end;

function LeerZeichenWeg(ss : PAnsiChar; Anf, Max : Integer) :integer;
Var k : integer;
begin
  Result := 0;
  For k:= Anf To Max Do begin  // alle Leerzeichen ausblenden
    if (ss[k] <> ' ') and (ss[k] <> #9) then begin
      exit;
    end;
    inc(Result);
  end;
end;

function GetTxtStart(ss : PAnsiChar; var Pos : Integer; Max : Integer) :Boolean;
Var k : integer;
begin
  For k:= Pos To Max Do begin  // alle Leerzeichen ausblenden
    if ss[k] = #0 then exit(false); // kein txt gefunden
    if (ss[k] <> ' ') and (ss[k] <> #9) then begin
      Pos := k;  //position des ersten Zeichens
      exit(true);
    end;
  end;
end;

function CopyUpCase(Qu, Zi : PAnsiChar; var Anf : Integer; Max : Integer) : integer;
Var k, ZiPos : Integer;
    c : Char;
begin
  ZiPos := 0;
  for k:= Anf To Max Do begin
    c := Qu[k];
    if (Qu[k] < #33) or (Qu[k] = '=') or (Qu[k] = ';') then begin
      Zi[ZiPos] := #0;
      Anf := k;
      exit(ZiPos); // Anz der copierten Bytes
    end else if Qu[k] >= 'a' then begin
      dec(C, $20);
      Zi[ZiPos] := c;
    end else  begin
      Zi[ZiPos] := Qu[k];
    end;
    inc(ZiPos);
  end; // Ziel jetzt in Großbuchstaben
end;

function CopyUpCaseEnde(Qu, Zi : PAnsiChar; Anf, Max : Integer; E : Char) : integer;
Var k, ZiPos : Integer;
    c : Char;
begin
  ZiPos := 0;
  for k:= Anf To Max Do begin
    if Qu[k] = E then begin
      Zi[ZiPos] := #0;
      exit(ZiPos); // Anz der copierten Bytes
    end else begin
      if Qu[k] < 'a' then begin
        Zi[ZiPos] := Qu[k];
      end else begin
        c := Qu[k];
        dec(C, $20);
        Zi[ZiPos] := c;
      end;
    end;
    inc(ZiPos);
  end; // Ziel jetzt in Großbuchstaben
end;

function CopyEnde(Qu, Zi : PAnsiChar; var Anf : Integer; Max : Integer; E : Char) : integer;
Var k, ZiPos : Integer;
begin
  ZiPos := 0;
  for k:= Anf To Max Do begin
    if Qu[k] = E then begin
      Zi[ZiPos] := #0;
      Anf := k;
      exit(ZiPos); // Anz der copierten Bytes
    end else begin
      Zi[ZiPos] := Qu[k];
    end;
    inc(ZiPos);
  end;
end;

Procedure Dat_Str(da :dat_sa; s:PAnsiChar);  //aus Datumssatz wird Str}
Var ss1 : Array[0..40] of AnsiChar;
begin
  ss1 := IntToStr(da.j);
  StrCopy5St(s, ss1, '_', ZiffAr_2[da.m], '_', ZiffAr_2[da.t]);
end;

Procedure Zeit_Str(Zs :Zeit_sa; ss : PAnsiChar);  //aus Zeitsatz wird Str}
begin
  ss[0]:= #0;
  With Zs do begin
    if s > 59  then s := 0;
    if mi > 59 then Mi := 0;
    if h > 24 then h := 0;
    StrCopy5St(ss, ZiffAr_2[h], ':', ZiffAr_2[mi], ':',ZiffAr_2[s]);
  end;
end;

Procedure Zeit_Str_SM(Zs :Zeit_sa; ss : PAnsiChar);  //aus Zeitsatz wird Str}
begin
  ss[0]:= #0;
  With Zs do begin
    if mi > 59 then Mi := 0;
    if h > 24 then h := 0;
    StrCopy3St(ss, ZiffAr_2[h], ':', ZiffAr_2[mi]);
  end;
end;

Procedure DatZeit_Str(dad :dat_sa; dat :Zeit_Sa; s:PAnsiChar);  {aus Datum und Zeitsatz wird Str}
Var ss1 : Array[0..40] of AnsiChar;
    PC : PAnsiChar;
begin
  ss1 := IntToStr(dad.j);
  PC := StrCopy7St(s, ZiffAr_2[dad.t], '.', ZiffAr_2[dad.m], '.', ss1, ' - ', ZiffAr_2[dat.h]);
  StrCopy4St(PC, ':', ZiffAr_2[dat.mi], ':', ZiffAr_2[dat.s]);
end;

procedure StrDisposeAndNil(var PAC );
begin
 if PAnsiChar(PAC) <> Nil then StrDispose(PAnsiChar(PAC));
 PAnsiChar(PAC) := Nil;
end;

initialization
  SetProPfad;
finalization
  if ProPfad <> Nil then StrDispose(ProPfad);
end.

