unit main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, GraObj,
  aro_classes, aro_graphic_;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    MyGraObj : TAroGraObj;
  public
  end;

var Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  MyGraObj := TAroGraObj.Create(self);
  MyGraObj.Parent := self;
  MyGraObj.Left:= 20;
  MyGraObj.Width:= 600;
  MyGraObj.Top:= 20;
  MyGraObj.Height:= 400;
end;

procedure TForm1.Button1Click(Sender: TObject);
Var BM, BM_ : TAroDib;
    Ss : Array [0..255] of AnsiChar;
begin
  BM := MyGraObj.AroBM;
  BM.Clear(clWhite);
  BM.LineHor(0, 3, 600, clRed);
  BM.LineHor(0, 6, 600, clBlue);
  BM.LineHor(0, 9, 600, clLime);
  BM.LineVert(3, 0, 400, clRed);
  BM.LineVert(6, 0, 400, clBlue);
  BM.LineVert(9, 0, 400, clLime);

  BM.ClearBereich(20, 20, 20,  20, clRed);
  BM.ClearBereich(40, 40, 20,  20, clBlue);
  BM.ClearBereich(60, 60, 20,  20, clLime);
  BM.DrawEllipseFill(160,160, 100,100 , clRed);
  BM.DrawEllipseFill(140,140, 80,80 , clBlue);
  BM.DrawEllipseFill(120,120, 60,60 , clLime);

  BM.DrawEllipseFillHQ(360,160, 100,100 , clRed);
  BM.DrawEllipseFillHQ(340,140, 80,80 , clBlue);
  BM.DrawEllipseFillHQ(320,120, 60,60 , clLime);

  BM.ClearBereich(40, 280, 200,  30, clRed);
  BM.ClearBereich(40, 320, 200,  30, clBlue);
  BM.ClearBereich(40, 360, 200,  30, clLime);
  BM.DrawTextLi( 42,282, clWhite, 'Text Links' );
  BM.DrawTextRe(238,322, clYellow, 'Text Rechts' );
  BM.DrawTextZentr(40,360, 200, 30, clBlack, 'Text Zentriert' );

  StrCopy2St(ss, ProPfad, 'cc.bmp');
  BM_ := TAroDib.CreateFromBM(ss);
  BM_.CopyToTAroDib(BM,420,250, 0,0, 200, 200);

  MyGraObj.Paint;
end;

procedure TForm1.Button2Click(Sender: TObject);
Var BM : TAroDib;
    Ss : Array [0..255] of AnsiChar;
begin
  StrCopy2St(ss, ProPfad, 'cc.bmp');
  BM := TAroDib.CreateFromBM(ss);
  StrCopy2St(ss, ProPfad, 'cc.agf');
  BM.SaveToAGF(ss);
end;



end.

